/* Sistemas Integrados TECNISA
   Recursos Humanos

Nome: 9501_RHMSTP_CALCULA_AUSENCIA.SQL

Descrio:
Clculo do tempo de ausncia do funcionrio.

P_CDEMPRESA - Cdigo da Empresa
P_CDFILIAL  - Cdigo da Filial
P_CDFUNC    - Cdigo do Funcionrio
P_DTPONTO   - Data do Ponto

Para aplicar e debugar
-- @H:\SISTEMAS\DBA\SQL\ORACLE\9501_RHMSTP_CALCULA_AUSENCIA.SQL
-- EXECUTE CALCULA_AUSENCIA('01', '9999', '0000000002', TO_DATE('28022000','DDMMYYYY'), :EDER)
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
??/??/99 - ?
*/

CREATE OR REPLACE PROCEDURE CALCULA_AUSENCIA
(P_CDEMPRESA IN PONTO.CDEMPRESA%TYPE,
 P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
 P_CDFUNC    IN PONTO.CDFUNC%TYPE,
 P_DTPONTO   IN PONTO.DTPONTO%TYPE,
 P_AUSENCIA  OUT VARCHAR2)

AS

   V_HORASAID  VARCHAR2(04);
   V_HORAENTR  VARCHAR2(04);
   V_HORATOTA  VARCHAR2(04);
   V_IDEVENPTO VARCHAR2(04);
   V_TIPOAPON  VARCHAR2(02);
   V_TPHORARIO VARCHAR2(01);
   V_HRENT1    VARCHAR2(04);
   V_HRSAI1    VARCHAR2(04);
   V_HRENT2    VARCHAR2(04);
   V_HRSAI2    VARCHAR2(04);

BEGIN
   V_HORATOTA := '0000';
   FOR C_PONTO IN (SELECT
                      DTHRPONTO,
                      IDEVENPONTO
                   FROM
                      PONTO
                   WHERE
                      (CDEMPRESA = P_CDEMPRESA) AND
                      (CDFUNC    = P_CDFUNC)    AND
                      (DTPONTO   = P_DTPONTO)
                   ORDER BY
                      DTHRPONTO) LOOP
      IF C_PONTO.IDEVENPONTO = 'SE' THEN
         V_HORASAID := TO_CHAR(C_PONTO.DTHRPONTO, 'HH24MI');
      ELSIF C_PONTO.IDEVENPONTO = 'RE' THEN
         V_HORAENTR := TO_CHAR(C_PONTO.DTHRPONTO, 'HH24MI');
         V_HORATOTA := UTILIT.SOMA_HORA(V_HORATOTA, UTILIT.SUBT_HORA2(V_HORAENTR, V_HORASAID));
      END IF;
      V_IDEVENPTO := C_PONTO.IDEVENPONTO;
   END LOOP;

   IF V_IDEVENPTO = 'SE' THEN
      SELECT
         MAX(IDTIPOAPON),
         MAX(IDTPHORARIO)
      INTO
         V_TIPOAPON,
         V_TPHORARIO
      FROM
         PAR_FILIAL_RH
      WHERE
         (CDFILIAL = P_CDFILIAL);

      SELECT
         MAX(TO_CHAR(HRENT1HBFUN, 'HH24MI')),
         MAX(TO_CHAR(HRSAI1HBFUN, 'HH24MI')),
         MAX(TO_CHAR(HRENT2HBFUN, 'HH24MI')),
         MAX(TO_CHAR(HRSAI2HBFUN, 'HH24MI'))
      INTO
         V_HRENT1,
         V_HRSAI1,
         V_HRENT2,
         V_HRSAI2
      FROM
         HORBASFU
      WHERE
         (CDEMPRESA   = P_CDEMPRESA)             AND
         (CDFUNC      = P_CDFUNC)                AND
         (IDDIHBFUN   = TO_CHAR(P_DTPONTO, 'D')) AND
         (DTINICHBFUN = (SELECT
                            MAX(DTINICHBFUN)
                         FROM
                            HORBASFU
                         WHERE
                            (CDEMPRESA    = P_CDEMPRESA)             AND
                            (CDFUNC       = P_CDFUNC)                AND
                            (IDDIHBFUN    = TO_CHAR(P_DTPONTO, 'D')) AND
                            (DTINICHBFUN <= P_DTPONTO)));

      /* FALTA TRATAR TIPO DE HORARIO IGUAL A ESCALA DE TRABALHO */

      IF NOT V_HRENT1 IS NULL THEN
         IF V_TPHORARIO = 'H' THEN
            IF V_TIPOAPON = 'TH' THEN
               IF V_HORASAID <= V_HRSAI1 THEN
                  V_HORATOTA := UTILIT.SOMA_HORA(V_HORATOTA, UTILIT.SUBT_HORA2(V_HRSAI1, V_HORASAID));
                  V_HORATOTA := UTILIT.SOMA_HORA(V_HORATOTA, UTILIT.SUBT_HORA2(V_HRSAI2, V_HRENT2));
               ELSE
                  V_HORATOTA := UTILIT.SOMA_HORA(V_HORATOTA, UTILIT.SUBT_HORA2(V_HRSAI2, V_HORASAID));
               END IF;
            ELSE
               V_HORATOTA := UTILIT.SOMA_HORA(V_HORATOTA, UTILIT.SUBT_HORA2(V_HRSAI2, V_HORASAID));
            END IF;
         END IF;
      END IF;
   END IF;

   P_AUSENCIA := V_HORATOTA;
END;
/

