CREATE OR REPLACE PROCEDURE INTEGRACAO_PACIENTE_TEK
IS
   V_CDFILIAL    VARCHAR2(04) := '9999';
   V_EXIST       VARCHAR2(20);
   V_CDLEITO     VARCHAR2(12);
   V_IDPACIENT   VARCHAR2(1) := '0';
   V_CONST_N     VARCHAR2(1) := 'N';
   V_CONST_S     VARCHAR2(1) := 'S';
   V_CDTABECDIPA VARCHAR2(7);
   V_CDDIAGNOST  VARCHAR2(10);
   V_DTINTERNA   DATE;

BEGIN

   /*VERIFICA CODIGO DA TABELA CID*/

   SELECT MAX(CDTABECDIPA)
     INTO V_CDTABECDIPA
     FROM PARAMGERAL
    WHERE (1 = 1);

   /*
   || Processamento dos evento de pacientes internados e com
   || leito alocado.
   */

   FOR v_alocacao IN ( SELECT *
                        FROM tecnisa_si3.vw_evento_alocacao ) LOOP

      BEGIN

        /*VERIFICAR SE J EXISTE O PACIENTE CADASTRADO*/
         SELECT MAX(CDPACIENTE)
           INTO V_EXIST
           FROM PACIENTE
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDPACIENTE = TO_CHAR(v_alocacao.CD_PACIENTE));

         IF (V_EXIST IS NULL) THEN
            INSERT INTO PACIENTE (CDFILIAL, CDPACIENTE, NMPACIENTE, NMSOBRNOME,
                                  IDSEXOPACI, DTNASCPACI, IDPACIENT, NMPACIUPPER)
                          VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.CD_PACIENTE), v_alocacao.NM_PACIENTE,
                                  SUBSTR(v_alocacao.NM_PACIENTE, INSTR(v_alocacao.NM_PACIENTE,' ',-1,1)+1,15),
                                  DECODE(v_alocacao.SEXO, 'M','0', DECODE(v_alocacao.SEXO, 'F', '1','3')),
                                  v_alocacao.DT_NASCTO, V_IDPACIENT, UPPER(v_alocacao.NM_PACIENTE));

         END IF;

         /*VERIFICAR SE J EXISTE O LEITO CADASTRADO*/

         SELECT MAX(CDLEITO)
            INTO V_EXIST
         FROM LEITO
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDLEITO  = TO_CHAR(v_alocacao.LEITO_ATUAL));

         IF (V_EXIST IS NULL) THEN

            /*VERIFICAR SE J EXISTE O ANDAR CADASTRADO*/

            SELECT MAX(CDANDAR)
              INTO V_EXIST
            FROM ANDAR
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDANDAR  = TO_CHAR(v_alocacao.ANDAR_LEITO));

            IF (V_EXIST IS NULL) THEN
               INSERT INTO ANDAR (CDFILIAL, CDANDAR, NMANDAR)
                          VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.ANDAR_LEITO), TO_CHAR(v_alocacao.ANDAR_LEITO));
            END IF;

            /*VERIFICAR SE J EXISTE O ALA CADASTRADA*/

            SELECT MAX(CDALA)
               INTO V_EXIST
            FROM ALA
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDALA    = TO_CHAR(v_alocacao.CD_ALA_LEITO));
            IF (V_EXIST IS NULL) THEN
               INSERT INTO ALA (CDFILIAL, CDALA, NMALA)
                        VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.CD_ALA_LEITO), TO_CHAR(v_alocacao.CD_ALA_LEITO));
            END IF;

            /*VEIFICAR SE EXISTE CADASTRADA A LIGAO DE ALA E ANDAR*/

            SELECT MAX(CDALA)
               INTO V_EXIST
            FROM ALANDAR
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDALA    = TO_CHAR(v_alocacao.CD_ALA_LEITO))
              AND (CDANDAR  = TO_CHAR(v_alocacao.ANDAR_LEITO));
            IF (V_EXIST IS NULL) THEN
               INSERT INTO ALANDAR (CDFILIAL, CDALA, CDANDAR)
                            VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.CD_ALA_LEITO), TO_CHAR(v_alocacao.ANDAR_LEITO));
            END IF;

            INSERT INTO LEITO (CDFILIAL, CDLEITO, NMLEITO, CDANDAR, CDALA)
                       VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.LEITO_ATUAL), v_alocacao.LEITO_ATUAL,
                               TO_CHAR(v_alocacao.ANDAR_LEITO), TO_CHAR(v_alocacao.CD_ALA_LEITO));
         END IF;

         /*VERIFICAR SE J EXISTE O PADRAO DE INTERNACAO CADASTRAD0*/

         SELECT MAX(CDSERPADDIE)
            INTO V_EXIST
         FROM PADRAOSERV
         WHERE (CDSERPADDIE = TO_CHAR(v_alocacao.TP_PROVEDOR));
         IF (V_EXIST IS NULL) THEN
            INSERT INTO PADRAOSERV (CDSERPADDIE, NMSERPADDIE)
                            VALUES (TO_CHAR(v_alocacao.TP_PROVEDOR), TO_CHAR(v_alocacao.TP_PROVEDOR));
         END IF;

         INSERT INTO INTERNAC (CDFILIAL, CDPACIENTE, DTINTERNA, CDSERPADDIE, CDLEITO)
         VALUES (V_CDFILIAL, TO_CHAR(v_alocacao.CD_PACIENTE), v_alocacao.DT_INTERNACAO,
                 TO_CHAR(v_alocacao.TP_PROVEDOR), TO_CHAR(v_alocacao.LEITO_ATUAL));

         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_S
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO  = TO_CHAR(v_alocacao.LEITO_ATUAL));

         IF (NOT TO_CHAR(v_alocacao.DIAG_CID10) IS NULL) THEN

            SELECT MAX(CDDIAGNOST)
              INTO V_CDDIAGNOST
            FROM DIAGNOST
            WHERE (CDTABECDI = V_CDTABECDIPA)
              AND (CDDIAGNOST = TO_CHAR(v_alocacao.DIAG_CID10));

            IF (NOT V_CDDIAGNOST IS NULL) THEN

               SELECT MAX(CDDIAGNOST)
                 INTO V_CDDIAGNOST
               FROM DIAGINTER
               WHERE (CDFILIAL = V_CDFILIAL)
                 AND (CDPACIENTE = TO_CHAR(v_alocacao.CD_PACIENTE))
                 AND (DTINTERNA = v_alocacao.DT_INTERNACAO)
                 AND (CDDIAGNOST = TO_CHAR(v_alocacao.DIAG_CID10));

               IF (V_CDDIAGNOST IS NULL) THEN
                  INSERT INTO DIAGINTER (CDPACIENTE, DTINTERNA, CDDIAGNOST, CDTABECDI, CDFILIAL, NRSEQUPRIO)
                              VALUES (TO_CHAR(v_alocacao.CD_PACIENTE),
                                      v_alocacao.DT_INTERNACAO,
                                      TO_CHAR(v_alocacao.DIAG_CID10),
                                      V_CDTABECDIPA,
                                      V_CDFILIAL, '00');

               END IF;
            END IF;
         END IF;

         /*
         || Registramos um controle do evento de alocao como j integrado ao sistema TECNISA.
         || Dessa forma, este evento ser desprezado na prxima consulta.
         */

         tecnisa_si3.pkg_tecnisa_si3.registrar_ctrl_aloc_enviada( p_adm_inst_cd => v_alocacao.adm_inst_cd,
                                                                  p_adm_ano     => v_alocacao.adm_ano,
                                                                  p_adm_nr      => v_alocacao.adm_nr,
                                                                  p_nr_leito    => v_alocacao.leito_atual );

      EXCEPTION
         WHEN OTHERS THEN
           tecnisa_si3.pkg_tecnisa_si3.write_log( p_tp_evento   => 'INTERNACAO',
                                                  p_adm_inst_cd => v_alocacao.adm_inst_cd,
                                                  p_adm_ano     => v_alocacao.adm_ano,
                                                  p_adm_nr      => v_alocacao.adm_nr,
                                                  p_nr_leito    => v_alocacao.leito_atual,
                                                  p_cd_erro     => SQLCODE,
                                                  p_ds_erro     => SQLERRM );
      END;

   END LOOP;

   COMMIT;

   /*
   || Processamento dos eventos de transferncia leitos.
   ||
   || Se algum paciente, j integrado ao sistema TECNISA, tiver uma
   || mudana de leito no SI3, esta ser atualizada no sistema TECNISA.
   */

   FOR v_transferencia IN ( SELECT *
                            FROM tecnisa_si3.vw_evento_transf_leito ) LOOP
      BEGIN

         /*VERIFICAR SE J EXISTE O LEITO CADASTRADO*/

         SELECT MAX(CDLEITO)
            INTO V_EXIST
         FROM LEITO
         WHERE (CDFILIAL = V_CDFILIAL)
           AND (CDLEITO  = TO_CHAR(v_transferencia.LEITO_ATUAL));

         IF (V_EXIST IS NULL) THEN

            /*VERIFICAR SE J EXISTE O ANDAR CADASTRADO*/

            SELECT MAX(CDANDAR)
              INTO V_EXIST
            FROM ANDAR
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDANDAR  = TO_CHAR(v_transferencia.ANDAR_LEITO));

            IF (V_EXIST IS NULL) THEN
               INSERT INTO ANDAR (CDFILIAL, CDANDAR, NMANDAR)
                          VALUES (V_CDFILIAL, TO_CHAR(v_transferencia.ANDAR_LEITO), TO_CHAR(v_transferencia.ANDAR_LEITO));
            END IF;

            /*VERIFICAR SE J EXISTE O ALA CADASTRADA*/

            SELECT MAX(CDALA)
               INTO V_EXIST
            FROM ALA
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDALA    = TO_CHAR(v_transferencia.CD_ALA_LEITO));
            IF (V_EXIST IS NULL) THEN
               INSERT INTO ALA (CDFILIAL, CDALA, NMALA)
                        VALUES (V_CDFILIAL, TO_CHAR(v_transferencia.CD_ALA_LEITO), TO_CHAR(v_transferencia.CD_ALA_LEITO));
            END IF;

            /*VEIFICAR SE EXISTE CADASTRADA A LIGAO DE ALA E ANDAR*/

            SELECT MAX(CDALA)
               INTO V_EXIST
            FROM ALANDAR
            WHERE (CDFILIAL = V_CDFILIAL)
              AND (CDALA    = TO_CHAR(v_transferencia.CD_ALA_LEITO))
              AND (CDANDAR  = TO_CHAR(v_transferencia.ANDAR_LEITO));
            IF (V_EXIST IS NULL) THEN
               INSERT INTO ALANDAR (CDFILIAL, CDALA, CDANDAR)
                            VALUES (V_CDFILIAL, TO_CHAR(v_transferencia.CD_ALA_LEITO), TO_CHAR(v_transferencia.ANDAR_LEITO));
            END IF;

            INSERT INTO LEITO (CDFILIAL, CDLEITO, NMLEITO, CDANDAR, CDALA)
                       VALUES (V_CDFILIAL, TO_CHAR(v_transferencia.LEITO_ATUAL), v_transferencia.LEITO_ATUAL,
                               TO_CHAR(v_transferencia.ANDAR_LEITO), TO_CHAR(v_transferencia.CD_ALA_LEITO));
         END IF;

         /* TROCAR O LEITO DA INTERNACAO*/

         SELECT CDLEITO, DTINTERNA
           INTO V_CDLEITO, V_DTINTERNA
           FROM INTERNAC
           WHERE CDFILIAL = V_CDFILIAL
             AND CDPACIENTE = TO_CHAR(v_transferencia.CD_PACIENTE)
             AND DTALTA IS NULL;

         UPDATE INTERNAC
            SET CDLEITO = TO_CHAR(v_transferencia.LEITO_ATUAL)
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDPACIENTE = TO_CHAR(v_transferencia.CD_PACIENTE))
            AND (DTINTERNA = V_DTINTERNA);

         /*DESOCULPA O LEITO ANTERIOR*/

         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_N
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO = V_CDLEITO);

         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_S
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO  = TO_CHAR(v_transferencia.LEITO_ATUAL));

         /*
         || Registramos um controle do evento de transferncia como j integrado ao sistema TECNISA.
         || Dessa forma, este evento ser desprezado na prxima consulta.
         */

         tecnisa_si3.pkg_tecnisa_si3.registrar_ctrl_transf_leito ( p_adm_inst_cd => v_transferencia.adm_inst_cd,
                                                                   p_adm_ano     => v_transferencia.adm_ano,
                                                                   p_adm_nr      => v_transferencia.adm_nr,
                                                                   p_nr_leito    => v_transferencia.leito_atual );
      EXCEPTION
         WHEN OTHERS THEN
            tecnisa_si3.pkg_tecnisa_si3.write_log( p_tp_evento   => 'TROCA DE LEITO',
                                                   p_adm_inst_cd => v_transferencia.adm_inst_cd,
                                                   p_adm_ano     => v_transferencia.adm_ano,
                                                   p_adm_nr      => v_transferencia.adm_nr,
                                                   p_nr_leito    => v_transferencia.leito_atual,
                                                   p_cd_erro     => SQLCODE,
                                                   p_ds_erro     => SQLERRM );
      END;
   END LOOP;

   COMMIT;

   /*
   || Processamento dos eventos de sadas (por alta ou cancelamento da admisso).
   */

   FOR v_saida IN ( SELECT *
                    FROM tecnisa_si3.vw_evento_saida ) LOOP

      BEGIN

         SELECT CDLEITO, DTINTERNA
           INTO V_CDLEITO, V_DTINTERNA
           FROM INTERNAC
           WHERE CDFILIAL = V_CDFILIAL
             AND CDPACIENTE = TO_CHAR(v_saida.CD_PACIENTE)
             AND DTALTA IS NULL;

         UPDATE INTERNAC
            SET DTALTA  = v_saida.DT_EVENTO,
                IDMOTIALTA = DECODE(v_saida.TP_EVENTO, 'OB', '1', '0')
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDPACIENTE = TO_CHAR(v_saida.CD_PACIENTE))
            AND (DTINTERNA  = V_DTINTERNA);

         /*DESOCULPA O LEITO ANTERIOR*/

         UPDATE LEITO
            SET IDOCUPLEITO = V_CONST_N
          WHERE (CDFILIAL = V_CDFILIAL)
            AND (CDLEITO = V_CDLEITO);

         /*
         || Registramos um controle do evento de sada como j integrado ao sistema TECNISA.
         || Dessa forma, este evento ser desprezado na prxima consulta.
         */
         tecnisa_si3.pkg_tecnisa_si3.registrar_ctrl_evento_saida ( p_adm_inst_cd => v_saida.adm_inst_cd,
                                                                   p_adm_ano     => v_saida.adm_ano,
                                                                   p_adm_nr      => v_saida.adm_nr,
                                                                   p_tp_evento   => v_saida.tp_evento );
      EXCEPTION
         WHEN OTHERS THEN
            tecnisa_si3.pkg_tecnisa_si3.write_log( p_tp_evento   => 'SAIDA',
                                                   p_adm_inst_cd => v_saida.adm_inst_cd,
                                                   p_adm_ano     =>  v_saida.adm_ano,
                                                   p_adm_nr      => v_saida.adm_nr,
                                                   p_nr_leito    => NULL,
                                                   p_cd_erro     => SQLCODE,
                                                   p_ds_erro     => SQLERRM );

      END;
   END LOOP;

   COMMIT;

END;
/
